#include <Adafruit_NeoPixel.h>
#ifdef __AVR__
  #include <avr/power.h>
#endif
#define PIN            9
#define NUMPIXELS      12
#define TARGET         3
#define SETS           4
#define BRIGHTNESS     20

Adafruit_NeoPixel Mypixels = Adafruit_NeoPixel(NUMPIXELS, PIN, NEO_GRB + NEO_KHZ800);

int Flag_TARGET=0;
int Flag_SETS=0;
int SETS_Count=0;
int TARGET_Count=6;

void setup()
{
  Mypixels.begin();
  Mypixels.setBrightness(BRIGHTNESS);
  pinMode(TARGET, INPUT);
  pinMode(SETS, INPUT);
  delay(500);
  for(int j=0; j<NUMPIXELS; j++)
  {
    Mypixels.setPixelColor(j,Mypixels.Color(0,0,0));
  }
  Mypixels.show();
  delay(3);
  openingAnimation();
}

void loop()
{
  if(digitalRead(TARGET)&& !Flag_TARGET)
  {
    delay(100);
    Flag_TARGET=1;
    TARGET_Count++;
    if(TARGET_Count<=12)
      Mypixels.setPixelColor(TARGET_Count-1,Mypixels.Color(0,255,255));
    if(TARGET_Count>12)
    {
      TARGET_Count=6;
      for(int i=6; i<12; i++)
      {
        Mypixels.setPixelColor(i,Mypixels.Color(0,0,0));
      }
    }
    Mypixels.show();
    delay(3);
  }
  if(!digitalRead(TARGET))
  {
    Flag_TARGET=0;
    delay(100);
  }

  if(digitalRead(SETS)&& !Flag_SETS)
  {
    delay(100);
    Flag_SETS=1;
    if(TARGET_Count>6)
    {
      SETS_Count++;
      Mypixels.setPixelColor(SETS_Count-1,Mypixels.Color(255,64,32));
      Mypixels.show();
      delay(3);
    }
  }
  if(!digitalRead(SETS))
  {
    Flag_SETS=0;
    delay(100);
  }

  if(SETS_Count==(TARGET_Count-6) && SETS_Count!=0)
  {
    startAnimation();
    SETS_Count=0;
    TARGET_Count=6;
  }
}

void startAnimation()
{
    for(int i=255; i>=0; i--)
    {
      for(int j=0; j<NUMPIXELS; j++)
      {
        Mypixels.setPixelColor(j,Mypixels.Color(0,255,i));
      }
      Mypixels.show();
      delay(1);
    }
    for(int i=0; i<256; i++)
    {
      for(int j=0; j<NUMPIXELS; j++)
      {
        Mypixels.setPixelColor(j,Mypixels.Color(i,255,0));
      }
      Mypixels.show();
      delay(1);
    }
    for(int i=255; i>=0; i--)
    {
      for(int j=0; j<NUMPIXELS; j++)
      {
        Mypixels.setPixelColor(j,Mypixels.Color(255,i,0));
      }
      Mypixels.show();
      delay(1);
    }
    for(int i=0; i<256; i++)
    {
      for(int j=0; j<NUMPIXELS; j++)
      {
        Mypixels.setPixelColor(j,Mypixels.Color(255,0,i));
      }
      Mypixels.show();
      delay(1);
    }
    for(int i=255; i>=0; i--)
    {
      for(int j=0; j<NUMPIXELS; j++)
      {
        Mypixels.setPixelColor(j,Mypixels.Color(i,0,255));
      }
      Mypixels.show();
      delay(1);
    }
    for(int i=0; i<256; i++)
    {
      for(int j=0; j<NUMPIXELS; j++)
      {
        Mypixels.setPixelColor(j,Mypixels.Color(0,i,255));
      }
      Mypixels.show();
      delay(1);
    }
    for(int j=0; j<NUMPIXELS; j++)
      {
        Mypixels.setPixelColor(j,Mypixels.Color(0,0,0));
      }
      Mypixels.show();
      delay(1);
}

void openingAnimation()
{
  for (int i=0; i<2; i++)
  {
  Mypixels.setPixelColor(0,Mypixels.Color(255,64,32));
  Mypixels.setPixelColor(11,Mypixels.Color(0,255,255));
  Mypixels.show();
  delay(50);
  Mypixels.setPixelColor(0,Mypixels.Color(255/2,64/2,32/2));
  Mypixels.setPixelColor(1,Mypixels.Color(255,64,32));
  Mypixels.setPixelColor(11,Mypixels.Color(0,255/2,255/2));
  Mypixels.setPixelColor(10,Mypixels.Color(0,255,255));
  Mypixels.show();
  delay(50);
  Mypixels.setPixelColor(0,Mypixels.Color(255/4,64/4,32/4));
  Mypixels.setPixelColor(1,Mypixels.Color(255/2,64/2,32/2));
  Mypixels.setPixelColor(2,Mypixels.Color(255,64,32));
  Mypixels.setPixelColor(11,Mypixels.Color(0,255/4,255/4));
  Mypixels.setPixelColor(10,Mypixels.Color(0,255/2,255/2));
  Mypixels.setPixelColor(9,Mypixels.Color(0,255,255));
  Mypixels.show();
  delay(50);
  Mypixels.setPixelColor(0,Mypixels.Color(0,0,0));
  Mypixels.setPixelColor(1,Mypixels.Color(255/4,64/4,32/4));
  Mypixels.setPixelColor(2,Mypixels.Color(255/2,64/2,32/2));
  Mypixels.setPixelColor(3,Mypixels.Color(255,64,32));
  Mypixels.setPixelColor(11,Mypixels.Color(0,0,0));
  Mypixels.setPixelColor(10,Mypixels.Color(0,255/4,255/4));
  Mypixels.setPixelColor(9,Mypixels.Color(0,255/2,255/2));
  Mypixels.setPixelColor(8,Mypixels.Color(0,255,255));
  Mypixels.show();
  delay(50);
  Mypixels.setPixelColor(0,Mypixels.Color(0,0,0));
  Mypixels.setPixelColor(1,Mypixels.Color(0,0,0));
  Mypixels.setPixelColor(2,Mypixels.Color(255/4,64/4,32/4));
  Mypixels.setPixelColor(3,Mypixels.Color(255/2,64/2,32/2));
  Mypixels.setPixelColor(4,Mypixels.Color(255,64,32));
  Mypixels.setPixelColor(11,Mypixels.Color(0,0,0));
  Mypixels.setPixelColor(10,Mypixels.Color(0,0,0));
  Mypixels.setPixelColor(9,Mypixels.Color(0,255/4,255/4));
  Mypixels.setPixelColor(8,Mypixels.Color(0,255/2,255/2));
  Mypixels.setPixelColor(7,Mypixels.Color(0,255,255));
  Mypixels.show();
  delay(50);
  Mypixels.setPixelColor(0,Mypixels.Color(0,0,0));
  Mypixels.setPixelColor(1,Mypixels.Color(0,0,0));
  Mypixels.setPixelColor(2,Mypixels.Color(0,0,0));
  Mypixels.setPixelColor(3,Mypixels.Color(255/4,64/4,32/4));
  Mypixels.setPixelColor(4,Mypixels.Color(255/2,64/2,32/2));
  Mypixels.setPixelColor(5,Mypixels.Color(255,64,32));
  Mypixels.setPixelColor(11,Mypixels.Color(0,0,0));
  Mypixels.setPixelColor(10,Mypixels.Color(0,0,0));
  Mypixels.setPixelColor(9,Mypixels.Color(0,0,0));
  Mypixels.setPixelColor(8,Mypixels.Color(0,255/4,255/4));
  Mypixels.setPixelColor(7,Mypixels.Color(0,255/2,255/2));
  Mypixels.setPixelColor(6,Mypixels.Color(0,255,255));
  Mypixels.show();
  delay(50);
  Mypixels.setPixelColor(0,Mypixels.Color(0,0,0));
  Mypixels.setPixelColor(1,Mypixels.Color(0,0,0));
  Mypixels.setPixelColor(2,Mypixels.Color(0,0,0));
  Mypixels.setPixelColor(3,Mypixels.Color(0,0,0));
  Mypixels.setPixelColor(4,Mypixels.Color(255/4,64/4,32/4));
  Mypixels.setPixelColor(5,Mypixels.Color(255/2,64/2,32/2));
  Mypixels.setPixelColor(8,Mypixels.Color(0,0,0));
  Mypixels.setPixelColor(7,Mypixels.Color(0,255/4,255/4));
  Mypixels.setPixelColor(6,Mypixels.Color(0,255/2,255/2));
  Mypixels.show();
  delay(50);
  Mypixels.setPixelColor(0,Mypixels.Color(0,0,0));
  Mypixels.setPixelColor(1,Mypixels.Color(0,0,0));
  Mypixels.setPixelColor(2,Mypixels.Color(0,0,0));
  Mypixels.setPixelColor(3,Mypixels.Color(0,0,0));
  Mypixels.setPixelColor(4,Mypixels.Color(0,0,0));
  Mypixels.setPixelColor(5,Mypixels.Color(255/4,64/4,32/4));
  Mypixels.setPixelColor(7,Mypixels.Color(0,0,0));
  Mypixels.setPixelColor(6,Mypixels.Color(0,255/4,255/4));
  Mypixels.show();
  delay(50);
  Mypixels.setPixelColor(0,Mypixels.Color(0,0,0));
  Mypixels.setPixelColor(1,Mypixels.Color(0,0,0));
  Mypixels.setPixelColor(2,Mypixels.Color(0,0,0));
  Mypixels.setPixelColor(3,Mypixels.Color(0,0,0));
  Mypixels.setPixelColor(4,Mypixels.Color(0,0,0));
  Mypixels.setPixelColor(5,Mypixels.Color(0,0,0));
  Mypixels.setPixelColor(6,Mypixels.Color(0,0,0));
  Mypixels.show();
  delay(50);

/*-----------------------------------------------------------*/
  Mypixels.setPixelColor(5,Mypixels.Color(255,64,32));
  Mypixels.setPixelColor(6,Mypixels.Color(0,255,255));
  Mypixels.show();
  delay(50);
  Mypixels.setPixelColor(5,Mypixels.Color(255/2,64/2,32/2));
  Mypixels.setPixelColor(4,Mypixels.Color(255,64,32));
  Mypixels.setPixelColor(6,Mypixels.Color(0,255/2,255/2));
  Mypixels.setPixelColor(7,Mypixels.Color(0,255,255));
  Mypixels.show();
  delay(50);
  Mypixels.setPixelColor(5,Mypixels.Color(255/4,64/4,32/4));
  Mypixels.setPixelColor(4,Mypixels.Color(255/2,64/2,32/2));
  Mypixels.setPixelColor(3,Mypixels.Color(255,64,32));
  Mypixels.setPixelColor(6,Mypixels.Color(0,255/4,255/4));
  Mypixels.setPixelColor(7,Mypixels.Color(0,255/2,255/2));
  Mypixels.setPixelColor(8,Mypixels.Color(0,255,255));
  Mypixels.show();
  delay(50);
  Mypixels.setPixelColor(5,Mypixels.Color(0,0,0));
  Mypixels.setPixelColor(4,Mypixels.Color(255/4,64/4,32/4));
  Mypixels.setPixelColor(3,Mypixels.Color(255/2,64/2,32/2));
  Mypixels.setPixelColor(2,Mypixels.Color(255,64,32));
  Mypixels.setPixelColor(6,Mypixels.Color(0,0,0));
  Mypixels.setPixelColor(7,Mypixels.Color(0,255/4,255/4));
  Mypixels.setPixelColor(8,Mypixels.Color(0,255/2,255/2));
  Mypixels.setPixelColor(9,Mypixels.Color(0,255,255));
  Mypixels.show();
  delay(50);
  Mypixels.setPixelColor(5,Mypixels.Color(0,0,0));
  Mypixels.setPixelColor(4,Mypixels.Color(0,0,0));
  Mypixels.setPixelColor(3,Mypixels.Color(255/4,64/4,32/4));
  Mypixels.setPixelColor(2,Mypixels.Color(255/2,64/2,32/2));
  Mypixels.setPixelColor(1,Mypixels.Color(255,64,32));
  Mypixels.setPixelColor(6,Mypixels.Color(0,0,0));
  Mypixels.setPixelColor(7,Mypixels.Color(0,0,0));
  Mypixels.setPixelColor(8,Mypixels.Color(0,255/4,255/4));
  Mypixels.setPixelColor(9,Mypixels.Color(0,255/2,255/2));
  Mypixels.setPixelColor(10,Mypixels.Color(0,255,255));
  Mypixels.show();
  delay(50);
  Mypixels.setPixelColor(5,Mypixels.Color(0,0,0));
  Mypixels.setPixelColor(4,Mypixels.Color(0,0,0));
  Mypixels.setPixelColor(3,Mypixels.Color(0,0,0));
  Mypixels.setPixelColor(2,Mypixels.Color(255/4,64/4,32/4));
  Mypixels.setPixelColor(1,Mypixels.Color(255/2,64/2,32/2));
  Mypixels.setPixelColor(0,Mypixels.Color(255,64,32));
  Mypixels.setPixelColor(6,Mypixels.Color(0,0,0));
  Mypixels.setPixelColor(7,Mypixels.Color(0,0,0));
  Mypixels.setPixelColor(8,Mypixels.Color(0,0,0));
  Mypixels.setPixelColor(9,Mypixels.Color(0,255/4,255/4));
  Mypixels.setPixelColor(10,Mypixels.Color(0,255/2,255/2));
  Mypixels.setPixelColor(11,Mypixels.Color(0,255,255));
  Mypixels.show();
  delay(50);
  Mypixels.setPixelColor(5,Mypixels.Color(0,0,0));
  Mypixels.setPixelColor(4,Mypixels.Color(0,0,0));
  Mypixels.setPixelColor(3,Mypixels.Color(0,0,0));
  Mypixels.setPixelColor(2,Mypixels.Color(0,0,0));
  Mypixels.setPixelColor(1,Mypixels.Color(255/4,64/4,32/4));
  Mypixels.setPixelColor(0,Mypixels.Color(255/2,64/2,32/2));
  Mypixels.setPixelColor(9,Mypixels.Color(0,0,0));
  Mypixels.setPixelColor(10,Mypixels.Color(0,255/4,255/4));
  Mypixels.setPixelColor(11,Mypixels.Color(0,255/2,255/2));
  Mypixels.show();
  delay(50);
  Mypixels.setPixelColor(5,Mypixels.Color(0,0,0));
  Mypixels.setPixelColor(4,Mypixels.Color(0,0,0));
  Mypixels.setPixelColor(3,Mypixels.Color(0,0,0));
  Mypixels.setPixelColor(2,Mypixels.Color(0,0,0));
  Mypixels.setPixelColor(1,Mypixels.Color(0,0,0));
  Mypixels.setPixelColor(0,Mypixels.Color(255/4,64/4,32/4));
  Mypixels.setPixelColor(10,Mypixels.Color(0,0,0));
  Mypixels.setPixelColor(11,Mypixels.Color(0,255/4,255/4));
  Mypixels.show();
  delay(50);
  Mypixels.setPixelColor(5,Mypixels.Color(0,0,0));
  Mypixels.setPixelColor(4,Mypixels.Color(0,0,0));
  Mypixels.setPixelColor(3,Mypixels.Color(0,0,0));
  Mypixels.setPixelColor(2,Mypixels.Color(0,0,0));
  Mypixels.setPixelColor(1,Mypixels.Color(0,0,0));
  Mypixels.setPixelColor(0,Mypixels.Color(0,0,0));
  Mypixels.setPixelColor(11,Mypixels.Color(0,0,0));
  Mypixels.show();
  delay(50);
  }
}

